﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;
using System.Collections;
using System.Threading;

namespace Kudy_tudy_cesticka
{
    public partial class Form1 : Form
    {
        string server;
        struct Request
        {
            public HttpWebRequest request;
            //public IAsyncResult result;
            public int index;
            public int x, y;
        }
        //LinkedList<HttpWebRequest> requests=new LinkedList<HttpWebRequest>();
        Image[] images = new Image[1000];
        object[] lockImg=new object[1000];
        Queue<int> freeImg=new Queue<int>();
        Dictionary<string, int> imgIndex = new Dictionary<string, int>();
        Queue<string> unnecImg=new Queue<string>();
        Graphics g;
        Brush background = new SolidBrush(Color.FromArgb(248, 248, 248));
        int zoom=0;
        int centerImgX = 1;
        int centerImgY = 0;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            server = "192.168.2.76";
            změnitServerToolStripMenuItem_Click(sender, e);
            //server="http://" + server + "/";
            
            for(int i=0;i<images.Length;i++){
                freeImg.Enqueue(i);
                lockImg[i]=new object();
            }
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            g = this.CreateGraphics();
            for (int x = centerImgX - (int)Math.Ceiling(((double)this.ClientRectangle.Width) / 2 / 256);
                x <= centerImgX + (int)Math.Ceiling(((double)this.ClientRectangle.Width) / 2 / 256);
                x++)
                for (int y = centerImgY - (int)Math.Ceiling(((double)this.ClientRectangle.Height) / 2 / 256);
                    y <= centerImgY + (int)Math.Ceiling(((double)this.ClientRectangle.Height) / 2 / 256);
                    y++)
                        paintImg(x, y);
             
        }

        private void paintImg(int x, int y)
        {
            
            if((x<0)||(x>=Math.Pow(2,zoom)*3)||(y<0)||(y>=Math.Pow(2,zoom)*2)){
                g.FillRectangle(background,
                    (x - centerImgX) * 256-128+this.ClientSize.Width/2,
                    (y - centerImgY) * 256-128+this.ClientSize.Height/2,
                    256,256);
                return;
            }
            string path=zoom.ToString() + "/" + x.ToString() + "/" + y.ToString();
            int i;
            if (imgIndex.TryGetValue(path, out i))
            {
                lock(lockImg)
                    if(images[i]!=null)
                        g.DrawImage(images[i],
                            (x - centerImgX) * 256-128+this.ClientSize.Width/2,
                            (y - centerImgY) * 256-128+this.ClientSize.Height/2,
                            256,256);
                    else
                        g.FillRectangle(background,
                            (x - centerImgX) * 256 - 128 + this.ClientSize.Width / 2,
                            (y - centerImgY) * 256 - 128 + this.ClientSize.Height / 2,
                            256, 256);
            }
            else
            {
                
                Request r;
                r.request = (HttpWebRequest)WebRequest.Create("http://"+server+"/" + path + ".jpg");
                if (freeImg.Count > 0)
                    r.index = freeImg.Dequeue();
                else if (unnecImg.Count > 0)
                {
                    r.index = imgIndex[unnecImg.Peek()];
                    imgIndex.Remove(unnecImg.Dequeue());
                    images[r.index] = null;
                }
                else
                {
                    MessageBox.Show("Small cache");
                    return;
                }
                imgIndex.Add(path, r.index);
                r.x = x;
                r.y = y;
                unnecImg.Enqueue(path);
                
                Thread th=new Thread(new ParameterizedThreadStart(delegate(object obj){
                    r.request.BeginGetResponse(new AsyncCallback(getResponse),r);
                }));
                th.Start();
                
                g.FillRectangle(background,
                    (x - centerImgX) * 256-128+this.ClientSize.Width/2,
                    (y - centerImgY) * 256-128+this.ClientSize.Height/2,
                    256,256);
            }

        }

        private void getResponse(IAsyncResult result)
        {
            
            Request r =(Request) result.AsyncState;
            HttpWebResponse response=(HttpWebResponse)r.request.EndGetResponse(result);
            lock (lockImg[r.index])
                images[r.index] = Image.FromStream(response.GetResponseStream());
            
            this.Invoke(new Action<int,int>(paintImg),new object[]{r.x,r.y});
        }

        private void Form1_Resize(object sender, EventArgs e)
        {
            Form1_Paint(sender, new PaintEventArgs(g,ClientRectangle));
        }

        private void změnitServerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ServerChange dialog = new ServerChange();
            dialog.textBox1.Text = server;
            dialog.ShowDialog();
            server = dialog.textBox1.Text;
        }

        private void zadatSouřadniceToolStripMenuItem_Click(object sender, EventArgs e)
        {
            CordinatesChange dialog = new CordinatesChange();
            dialog.textBox1.Text = zoom.ToString();
            dialog.textBox2.Text = centerImgX.ToString();
            dialog.textBox3.Text = centerImgY.ToString();
            dialog.ShowDialog();
            if (dialog.valid)
            {
                centerImgX = dialog.x;
                centerImgY = dialog.y;
                zoom = dialog.zoom;
                this.OnPaint(new PaintEventArgs(g,this.ClientRectangle));
            }
            else
                MessageBox.Show("Chyba");
        }

        private void Form1_KeyUp(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
                case Keys.Right:
                    centerImgX++;
                    Form1_Paint(sender, new PaintEventArgs(g, this.ClientRectangle));
                    break;
                case Keys.Left:
                    centerImgX--;
                    Form1_Paint(sender, new PaintEventArgs(g, this.ClientRectangle));
                    break;
                case Keys.Up:
                    centerImgY--;
                    Form1_Paint(sender, new PaintEventArgs(g, this.ClientRectangle));
                    break;
                case Keys.Down:
                    centerImgY++;
                    Form1_Paint(sender, new PaintEventArgs(g, this.ClientRectangle));
                    break;
                case Keys.Subtract:
                    if (zoom > 0)
                    {
                        zoom--;
                        centerImgX /= 2;
                        centerImgY /= 2;
                        Form1_Paint(sender, new PaintEventArgs(g, this.ClientRectangle));
                    }
                    break;
                case Keys.Add:
                    if (zoom < 9)
                    {
                        zoom++;
                        centerImgX *= 2;
                        centerImgY *= 2;
                        Form1_Paint(sender, new PaintEventArgs(g, this.ClientRectangle));
                    }
                    break;
            }
            
            //MessageBox.Show(e.KeyCode.ToString());
        }





    }
}
